/// Теоретичні питання

// Опишіть своїми словами як працює метод forEach.
//Відповідь: цикл, що перебирає всі елементи масиву і виконує задану йому функцію для кожного елемента.

// Як очистити масив?
//Відповідь: задавши масиву length=0 => поверне пустий масив. задати поточному масиву пустий масив []. 
// склеїти увесь масив => arr.splice(0, arr.length).
// або можна за допомогою методу filter() створити новий масив, очистивши від тих елементів, 
// які не проходять умовам заданої в ньому функції. 

// Як можна перевірити, що та чи інша змінна є масивом?
//Відповідь: за допомогою Array.find(), яка поверне елемент, або arr.includes(elem). 
// ще можна через arr.indexOf(elem), яке при виконанні поверне індекс першого відповідного elem, або -1.

/// Завдання

// Реалізувати функцію фільтру масиву за вказаним типом даних. Завдання має бути виконане на чистому 
// Javascript без використання бібліотек типу jQuery або React.

// Технічні вимоги:
// Написати функцію filterBy(), яка прийматиме 2 аргументи. Перший аргумент - масив, який міститиме 
// будь-які дані, другий аргумент - тип даних.
// Функція повинна повернути новий масив, який міститиме всі дані, які були передані в аргумент, за 
// винятком тих, тип яких був переданий другим аргументом. Тобто якщо передати масив ['hello', 'world', 23, '23', null], 
// і другим аргументом передати 'string', то функція поверне масив [23, null].
const arr = ['hello', 'world', 23, '23', null];

let filterBy = (array, type) => array.filter(element => typeof element !== type)
    
const newArr = filterBy(arr, 'string');